function nonFBdraw()
		love.graphics.setColor(50,50,50)
		love.graphics.rectangle("fill",120,40,400,400)
		love.graphics.setColor(255,255,255)
		love.graphics.setLineWidth(3)
		love.graphics.rectangle("line",120,40,400,400)
		love.graphics.setColor(255,255,255)
		local boxsize = 400/9
		for x = 0,8 do
			for y = 0,8 do
				love.graphics.rectangle("line",120+x*boxsize,40+y*boxsize,boxsize,boxsize)
			end
		end
		love.graphics.setColor(2,200,200)
		boxsize = 400/3
		for x = 0,2 do
			for y = 0,2 do
				love.graphics.rectangle("line",120+x*boxsize,40+y*boxsize,boxsize,boxsize)
			end
		end
		love.graphics.setColor(255,255,255)
end

function love.load()
	
	
	font = love.graphics.newFont("Ubuntu-B.ttf",30)
	love.graphics.setFont(font)
	
	sudoku={{},{},{},{},{},{},{},{},{}}
	for x=1,9 do
		for y=1,9 do
			sudoku[x][y] = 0
		end
	end
	
	markx=0
	marky = 0
	solved=false
end

function love.draw()
	love.graphics.setColor(255,255,255)
	love.graphics.print("by T-Bone",10,442)
	--love.graphics.print(""..markx.." "..marky,10,10)
	if boxfb then love.graphics.draw(boxfb,120,40) else
		nonFBdraw()
	end
	for x = 1,9 do
		for y = 1,9 do
			if x==markx and y==marky then
				love.graphics.setColor(255,0,255)
				love.graphics.print(""..sudoku[x][y],135 + (x-1)*400/9,45 + (y-1)*400/9)
				love.graphics.setColor(255,255,255)
			else
				love.graphics.print(""..sudoku[x][y],135 + (x-1)*400/9,45 + (y-1)*400/9)
			end
		end
	end
end

function love.update(dt)

end

function love.mousepressed(x,y,button)
	if solved then return end
	currx,curry = getCoords(x,y)
	
	if currx > 0 and currx <= 9 and curry > 0 and curry <= 9 then
		markx=currx
		marky=curry
	end
end

function getCoords(mousex,mousey)
	local x = math.floor((mousex - 120) /  (400/9)) + 1
	local y = math.floor((mousey - 40) /  (400/9)) + 1
	return x,y
end

function love.keypressed(k)
	if k== "f" then
		boxfb = love.graphics.newFramebuffer(512,512)
		boxfb:renderTo(function()
		love.graphics.setColor(50,50,50)
		love.graphics.rectangle("fill",0,0,400,400)
		love.graphics.setColor(255,255,255)
		love.graphics.setLineWidth(3)
		love.graphics.rectangle("line",0,0,400,400)
		love.graphics.setColor(255,255,255)
		local boxsize = 400/9
		for x = 0,8 do
			for y = 0,8 do
				love.graphics.rectangle("line",x*boxsize,y*boxsize,boxsize,boxsize)
			end
		end
		love.graphics.setColor(2,200,200)
		boxsize = 400/3
		for x = 0,2 do
			for y = 0,2 do
				love.graphics.rectangle("line",x*boxsize,y*boxsize,boxsize,boxsize)
			end
		end
		love.graphics.setColor(255,255,255)
	end) return
	end
	
	
	if markx > 0 and marky > 0 and tonumber(k) then
		sudoku[markx][marky] = tonumber(k)
	end
	if k==" " and not solved then
		local lol = trueSolve()
		if lol then
			sudoku = lol
			solved=true
			currx=0
			curry=0
			markx=0
			marky=0
		end
	elseif k==" " and solved then
		solved=false
		sudoku={{},{},{},{},{},{},{},{},{}}
		for x=1,9 do
			for y=1,9 do
				sudoku[x][y] = 0
			end
		end
	end
end

function trueSolve()
	if solve(1,1) then
		return sudoku
	end
	return nil
end

function solve(i,j)
	a=sudoku[i][j]
	if a==0 then
		for test=1,9 do
			if testRowsAndColumbs(i,j,test) then
				sudoku[i][j]=test
				nextlol = nextlulz(i,j)
				if nextlol == nil then
					return true
				else
					if(solve(nextlol[1],nextlol[2])) then
						return true
					end
				end
			end
		
		end
		sudoku[i][j]=0
		return false
	else 
		if testRowsAndColumbs(i,j,a) then
			nextlol = nextlulz(i,j)
			if nextlol == nil then
				return true
			elseif solve(nextlol[1],nextlol[2]) then
				return true
			end
		end
		return false
	end
end

function testRowsAndColumbs(i,j,test)
	for a = 1,9 do
		if a ~= j and sudoku[i][a] == test then
			return false
		end
		if a ~= i and sudoku[a][j] == test then
			return false
		end
		
	end
	local xbox = math.floor((i-1)/3)
	local ybox = math.floor((j-1)/3)
	
	for x=1,3 do
		for y=1,3 do
			if (xbox*3 + x ~= i and ybox * 3 + y ~= j and sudoku[xbox*3+x][ybox*3+y]==test) then
				return false
			end
		end
	end
	return true
end

function nextlulz(i,j)
	result={}
	if i < 9 then
		result[1] = i+1
		result[2] = j
	else
		if j~=9 then
			result[1]=1
			result[2]=j+1
		else
			return nil
		end
		
	end
	return result
end
